//#ifndef VECPOT_H_
//#define VECPOT_H_
//
//
//
//#include <stdio.h>
//#include <iostream>
//#include <iomanip>
//#include <fstream>
//#include <string>
//#include <cstring>
//#include <cstdlib>
//#include <math.h>
//
//#include <complex>
//#include <vector>
//#include <gsl/gsl_math.h>
//#include <gsl/gsl_sf_gamma.h>
//
//#include "tArrayComplex2D_rt.h"
//
//#include "Constants.h"
//#include "options.h"
//#include "logbuch.h"
//#include "tools.h"
//
//
//
//
//class VecPot
//{
//public:
//	VecPot();
//	virtual ~VecPot();
//	
//	int init(class tArrayComplex2D_rt *laser);
//	int init(class tArrayComplex2D_rt *laser, double intmin, double intmax, int inN);
//	
//	double	at	(const double t);
//	double 	Int	(const double t1, const double t2);
//	double 	Int2(const double t1, const double t2);
////variables	
//	int Type;
//	class tArrayComplex2D_rt *laser;
//		
//private:
////variables
//	double w0,xlam,tau,tmin,tmax,dt; //tau : lifetime
//	Complex *VectorPotential;
//	Complex *IntegralA;
//	Complex *IntegralA2;
//	int Nr,Ntwm,ir,jt,  N,i,j,k;
//	double tmp1,tmp2;
//
//// Maxis and Minis
//	static const int Nmax = int(1e6);
//
////functions
//	int SetVecPotPointer(void);
//	int SupplyInterpolationPoints(void);
//	// mono
//	inline double	monoat	(const double t);
//	inline double 	monoInt	(const double t1, const double t2);
//	inline double 	monoInt2(const double t1, const double t2);
/////*	
// 	// nearest point
//	inline double	nearestat	(const double t);
//	inline double 	nearestInt	(const double t1, const double t2);
//	inline double 	nearestInt2 (const double t1, const double t2);
////*/
//	// linear interpolation
//	inline double	linat	(const double t);
//	inline double 	linInt	(const double t1, const double t2);
//	inline double 	linInt2 (const double t1, const double t2);
//
//
//
////function-Pointers
//	double 	(VecPot::* VecPotPtr)(const double t);
//	double 	(VecPot::* IntAPtr)  (const double t1, const double t2);	
//	double 	(VecPot::* IntA2Ptr) (const double t1, const double t2);		
//
//
//
//
//};
//
//#endif /*VECPOT_H_*/
