// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef GNUPLOT_H_
#define GNUPLOT_H_

// from gnuplot_i_c - example
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include  <complex>
#include <vector>
#include <math.h>

// from gnuplot_i_cc - example
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdexcept>
//#include <list>

#include "gnuplot_i_C.h"
#include "tools.h"



#define GP_MAX_TMP_FILES    64
#define GP_TMP_NAME_SIZE    512
#define GP_CMD_SIZE         1024
#define GP_TITLE_SIZE       80


inline double gplotfunc(const double r);
// *************************************************************************
// ***      gnuplot funktion fuer c++ ... inkl. png-plot moeglichkeit    ***
// *************************************************************************
int vecgplotplotxy(vector<double> xx, vector<double> yy, 
            double delay, int logscale, int terminaltype ,
            char *xlabel , char *ylabel, char *title, char *style );
// *************************************************************************
int gplotplotxy(int N, double x[], double y[], 
            double delay, int logscale, int terminaltype ,
            char *xlabel , char *ylabel, char *title, char *style ,char *filename, int filenr);
// *************************************************************************
int test_gnuplot(void);




class gnuplot
{
public:
	gnuplot();
	virtual ~gnuplot();
};

#endif /*GNUPLOT_H_*/
