// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef TOOLS_H_
#define TOOLS_H_

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <math.h>
#include <time.h>
#include <sys/time.h>
//#include <unistd.h>
#include <complex>
#include <vector>
//#include <gsl/gsl_math.h>
//#include <gsl/gsl_complex.h>
//#include <gsl/gsl_complex_math.h>
//#include <gsl/gsl_sf_bessel.h>
//#include <gsl/gsl_errno.h>
//#include <gsl/gsl_integration.h>
//#include <gsl/gsl_const_mksa.h>
//#include <gsl/gsl_fft_real.h>
//#include <gsl/gsl_fft_halfcomplex.h>
//#include <gsl/gsl_fft_complex.h>

#include "AnyOption.h"
#include "Definitions.h"
#include "Constants.h"

#include "options.h"
//#include "tArrayComplex2D_rt.h"

using namespace std;

/* Special Constants  ... */
const string xt_filetype("# Filetype: Dipolemoment x(t)");
const string xw_filetype("# Filetype: Dipolemoment x(omega)");
const string end_of_header("# ! End of Header !");
/* End of Special Constants ... */


string timestamp(void);

int systime_ms(double * milliseconds);


#endif /*TOOLS_H_*/
